
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>KSPDTM &#8212; K-shortest path direct travellers model  documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="dijkstraK" href="dijkstraK.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head>
  <body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="kspdtm">
<h1>KSPDTM<a class="headerlink" href="#kspdtm" title="Permalink to this headline">¶</a></h1>
<p>Direct travellers model solver for k-shortest path</p>
<div class="section" id="definition">
<h2>Definition<a class="headerlink" href="#definition" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal"><span class="pre">KSPDTM(G,k,tr,C,L,V,E,f_min=None,f_max=None)</span></code></p>
<div class="line-block">
<div class="line"><br /></div>
</div>
<dl class="docutils">
<dt><strong>Parameters</strong>:</dt>
<dd><ul class="first simple">
<li><strong>G</strong> (dictionary) Graph represented so as to be compatible with the function
<a class="reference external" href="dijkstraK.html">dijkstraK</a></li>
<li><strong>k</strong> (int) Number of shortest paths in the set of preferable paths</li>
<li><strong>tr</strong> (2d-array-like) Traffic demand matrix. For every <em>i</em> , <em>j</em> <strong>tr</strong> [<em>i</em>][<em>j</em>]
is the total number of passengers that need to travel from node <em>i</em> to node <em>j</em>
in a given time interval <em>I</em>.</li>
<li><strong>C</strong> (int) fixed vehicle capacity</li>
<li><strong>L</strong> (list) starting set of lines. Each element of this list is a line, which is represented as a list
of edges (an edge is represented as a list containing the two node linked by the edge)</li>
<li><strong>V</strong> (array-like) array of nodes of <strong>G</strong></li>
<li><strong>E</strong> (array-like) array of edges of <strong>G</strong></li>
<li><strong>f_min</strong> (array_like) array of minimum frequency allowed on each edge. If it is not given as an argument
it is estimated, together with <strong>f_max</strong> as <em>line-frequency requirement</em> (see below)</li>
<li><strong>f_max</strong> (array-like) array of maximum frequency allowed on each edge. If it is not given as an argument
while <strong>f_min</strong> is given, it is set to infinity.</li>
</ul>
<p class="last">The order of the values in <strong>f_min</strong> and <strong>f_max</strong> is referred to the vector <strong>E</strong></p>
</dd>
<dt><strong>Returns</strong>:</dt>
<dd><ul class="first last simple">
<li><strong>OPT</strong> (array-like) the last element of this list is an integer that represents the status of the
optimization process (1 = success). The second-to-last element is the value of the maximized objective
function. The remaining elements are the optimized values of line frequencies.</li>
</ul>
</dd>
</dl>
</div>
<div class="section" id="details">
<h2>Details<a class="headerlink" href="#details" title="Permalink to this headline">¶</a></h2>
<p>The <em>line-frequency requirement</em> for and edge <em>e</em> is defined as <code class="docutils literal"><span class="pre">tr[e]//C</span></code> where <strong>tr</strong> [<em>e</em>] is defined as the sum of
<strong>tr</strong> [<em>i</em>][<em>j</em>] for every pair of nodes <em>i</em> and <em>j</em> such that <em>e</em> is contained in one of the preferable paths between <em>i</em>
and <em>j</em>.</p>
<p>This routine uses <a class="reference external" href="dijkstraK.html">dijkstraK</a> to obtain the k-shortest paths between all pair of nodes, and
builds the direct travellers model’s objective function and constraint accordingly; this construction, together
with the resolution of the optimization problem, is done with the help of functions from the <a class="reference external" href="https://pythonhosted.org/PuLP/">PuLP</a> library.</p>
<p>In accordance with the original formulation of the direct travellers model, the variables representing the direct
travellers are treated as continuous, and only the line frequencies are constrained to be integer.</p>
</div>
<div class="section" id="examples">
<h2>Examples<a class="headerlink" href="#examples" title="Permalink to this headline">¶</a></h2>
<p>We consider the graph introduced in <a class="reference external" href="dijkstraK.html">dijkstraK</a>.
Let <strong>L</strong> contain the following lines:</p>
<blockquote>
<div><ol class="arabic simple">
<li>(1,3,6,7)</li>
<li>(2,3,6,8)</li>
<li>(5,6)</li>
<li>(3,6,5)</li>
<li>(2,3,4)</li>
<li>(4,5,6,3)</li>
<li>(3,4,5,6)</li>
<li>(1,3,4,5,6,7)</li>
</ol>
</div></blockquote>
<p>Let <strong>f_min</strong> = [3,4,3,4,10,8,3,3], <strong>f_max</strong> = 20 for every edge,
<strong>C</strong> = 300, and <strong>tr</strong> defined as follows:</p>
<div class="highlight-default"><div class="highlight"><pre><span></span><span class="o">|</span>   <span class="mi">0</span>   <span class="mi">10</span>   <span class="mi">20</span>   <span class="mi">10</span>  <span class="mi">60</span>   <span class="mi">100</span>    <span class="mi">0</span>    <span class="mi">0</span><span class="o">|</span>
<span class="o">|</span>  <span class="mi">10</span>    <span class="mi">0</span>   <span class="mi">40</span>   <span class="mi">20</span>  <span class="mi">70</span>   <span class="mi">100</span>    <span class="mi">1</span>   <span class="mi">10</span><span class="o">|</span>
<span class="o">|</span>  <span class="mi">20</span>   <span class="mi">40</span>    <span class="mi">0</span>   <span class="mi">20</span>  <span class="mi">100</span>   <span class="mi">50</span>   <span class="mi">20</span>   <span class="mi">10</span><span class="o">|</span>
<span class="o">|</span>  <span class="mi">10</span>   <span class="mi">20</span>   <span class="mi">20</span>    <span class="mi">0</span>  <span class="mi">100</span>  <span class="mi">150</span>    <span class="mi">0</span>    <span class="mi">0</span><span class="o">|</span>
<span class="o">|</span>  <span class="mi">60</span>   <span class="mi">70</span>  <span class="mi">100</span>  <span class="mi">100</span>    <span class="mi">0</span>  <span class="mi">120</span>  <span class="mi">100</span>   <span class="mi">90</span><span class="o">|</span>
<span class="o">|</span> <span class="mi">100</span>  <span class="mi">100</span>   <span class="mi">50</span>  <span class="mi">150</span>  <span class="mi">120</span>    <span class="mi">0</span>   <span class="mi">60</span>   <span class="mi">50</span><span class="o">|</span>
<span class="o">|</span>   <span class="mi">0</span>    <span class="mi">1</span>   <span class="mi">20</span>    <span class="mi">0</span>  <span class="mi">100</span>   <span class="mi">60</span>    <span class="mi">0</span>    <span class="mi">0</span><span class="o">|</span>
<span class="o">|</span>   <span class="mi">0</span>   <span class="mi">10</span>   <span class="mi">10</span>    <span class="mi">0</span>   <span class="mi">90</span>   <span class="mi">50</span>    <span class="mi">0</span>    <span class="mi">0</span><span class="o">|</span>
</pre></div>
</div>
<p>By calling <code class="docutils literal"><span class="pre">KSPDTM</span></code> with we obtain the optimal values for the lines frequencies:</p>
<blockquote>
<div><ol class="arabic simple">
<li>2</li>
<li>3</li>
<li>6</li>
<li>0</li>
<li>2</li>
<li>3</li>
<li>0</li>
<li>1</li>
</ol>
</div></blockquote>
<p>and the relative value of the objective function: 1860 (70% of total travellers)
for <strong>k</strong> = 1 and
2160 (82% of the total travellers) for <strong>k</strong> = 2.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">K-shortest path direct travellers model</a></h1>








<h3>Navigation</h3>
<p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="Introduction.html">Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="dijkstraK.html">dijkstraK</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">KSPDTM</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#definition">Definition</a></li>
<li class="toctree-l2"><a class="reference internal" href="#details">Details</a></li>
<li class="toctree-l2"><a class="reference internal" href="#examples">Examples</a></li>
</ul>
</li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="dijkstraK.html" title="previous chapter">dijkstraK</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2018, Armando Guardasole.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.6.3</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
      |
      <a href="_sources/KSPDTM.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>